﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BulletList
{
    public partial class Form1 : Form
    {
        bool first;
        public Form1()
        {
            first = true;
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {            
          FarPoint.Win.Spread.CellType.TextCellType t = new FarPoint.Win.Spread.CellType.TextCellType();         
          FarPoint.Win.Spread.InputMap ancestorOfFocusedMap = fpSpread1.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused);
          FarPoint.Win.Spread.ActionMap am = fpSpread1.GetActionMap();
          am.Put("AltEnter", new myAction());
          ancestorOfFocusedMap.Put(new FarPoint.Win.Spread.Keystroke(Keys.Enter, Keys.None), FarPoint.Win.Spread.SpreadActions.MoveToNextRow );
          ancestorOfFocusedMap.Put(new FarPoint.Win.Spread.Keystroke(Keys.Enter, Keys.Alt), "AltEnter");
          fpSpread1.SetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused, ancestorOfFocusedMap);
          t.Multiline = true;
          fpSpread1.Sheets[0].Cells[1, 1].CellType = t;
          fpSpread1.Sheets[0].Rows[1].Height = 60;
          fpSpread1.Sheets[0].Columns[1].Width = 140;
         

    }
    private void fpSpread1_EditModeOn_1(object sender, EventArgs e)
    {
        if (fpSpread1.ActiveSheet.ActiveColumnIndex == 1 && fpSpread1.ActiveSheet.ActiveRowIndex == 1)
        {
            FarPoint.Win.Spread.CellType.GeneralEditor myText = (FarPoint.Win.Spread.CellType.GeneralEditor)fpSpread1.EditingControl;
            myText.AcceptsReturn = false;
            if (first)
            {
                myText.Text = " \u2022 ";
                first = false;
            }
        }
    }
  }

  public class myAction : FarPoint.Win.Spread.Action
  {     
    public override void PerformAction(object sender)
    {
        FarPoint.Win.Spread.SpreadView ss = (FarPoint.Win.Spread.SpreadView)sender;
        FarPoint.Win.Spread.CellType.GeneralEditor editor = (FarPoint.Win.Spread.CellType.GeneralEditor)ss.EditingControl;
        string text = editor.Text;
        text += "\r\n \u2022 ";
        ss.Sheets[0].SetValue(ss.Sheets[0].ActiveRowIndex, ss.Sheets[0].ActiveColumnIndex, text);
        ss.EditMode = true;
        editor = (FarPoint.Win.Spread.CellType.GeneralEditor)ss.EditingControl;
        editor.SelectionStart = editor.Text.Length;
        editor.Text = text; 
      
    }
  }        
}
